#!/usr/bin/env python

# mintUpload
#	No Copyright (What for?) Clem <root@linuxmint.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; Version 2
# of the License.
#
# This program is "inspired" by CNR and the idea of "one click install". 


import sys

try:
     import pygtk
     pygtk.require("2.0")
except:
      pass
try:
    import gtk
    import gtk.glade
    import urllib
    import ftplib
    import os
    import threading
    import datetime
    import gettext
except:
    print "You do not have all the dependencies!"
    sys.exit(1)

gtk.gdk.threads_init()

# i18n
gettext.install("messages", "/usr/lib/linuxmint/mintUpload/locale")

class spaceChecker(threading.Thread):

    def run(self):
	global statusbar
	global context_id
	global wTree
	global space
	global maxsize
	global persistence

	wTree.get_widget("combo").set_sensitive(False)
	wTree.get_widget("upload_button").set_sensitive(False)

	statusbar.push(context_id, _("Checking space on the service..."))
	wTree.get_widget("main_window").window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))		
	# Get the available space left on the service
	try:
		spaceInfo = urllib.urlopen(space).read()
		spaceInfoArray = spaceInfo.split('/')	
		spaceAvailable = spaceInfoArray[0]
		spaceTotal = spaceInfoArray[1]
		pctSpace = float(spaceAvailable) / float(spaceTotal) * 100
		pctSpace = int(pctSpace)
		#spaceAvailableInMB = round(float(spaceAvailable) / 1000000, 2)
		spaceAvailable = float(spaceAvailable)
		spaceAvailableSTR = str(spaceAvailable) + _("B")
		if (spaceAvailable > 1000):
			spaceAvailableF = round(spaceAvailable/1000, 1)
			spaceAvailableSTR = str(spaceAvailableF) + _("KB")
		if (spaceAvailable > 1000000):
			spaceAvailableF = round(spaceAvailable/1000000, 1)
			spaceAvailableSTR = str(spaceAvailableF) + _("MB")
		if (spaceAvailable > 1000000000):
			spaceAvailableF = round(spaceAvailable/1000000000, 1)
			spaceAvailableSTR = str(spaceAvailableF) + _("GB")

		pctSpaceStr = spaceAvailableSTR + " (" + str(pctSpace) + "%)"
		wTree.get_widget("txt_space").set_label(pctSpaceStr)

		maxsize = float(maxsize)
		if (maxsize > 1000):
			maxsizeF = round(maxsize/1000, 1)
			maxsizeStr = str(maxsizeF) + _("KB")
		if (maxsize > 1000000):
			maxsizeF = round(maxsize/1000000, 1)
			maxsizeStr = str(maxsizeF) + _("MB")
		if (maxsize > 1000000000):
			maxsizeF = round(maxsize/1000000000, 1)
			maxsizeStr = str(maxsizeF) + _("GB")
		wTree.get_widget("txt_maxsize").set_label(maxsizeStr)	

		wTree.get_widget("txt_persistence").set_label(persistence + " " + _("days"))	

		#Activate the upload button if the space is OK	
		if (spaceAvailable >= filesize and filesize <= maxsize):
			wTree.get_widget("upload_button").set_sensitive(True)
			statusbar.push(context_id, "<span color='green'>" + _("Service ready. Space available.") + "</span>")
			label = statusbar.get_children()[0].get_children()[0]		
			label.set_use_markup(True)
		else:
			wTree.get_widget("upload_button").set_sensitive(False)
			statusbar.push(context_id, "<span color='red'>" + _("File too big or not enough space on the service.") + "</span>")
			label = statusbar.get_children()[0].get_children()[0]		
			label.set_use_markup(True)
	except Exception, detail:
		print detail	
		statusbar.push(context_id, "<span color='red'>" + _("Could not connect to the service.") + "</span>")
		label = statusbar.get_children()[0].get_children()[0]		
		label.set_use_markup(True)
		wTree.get_widget("upload_button").set_sensitive(False)
		
	finally:
		wTree.get_widget("main_window").window.set_cursor(None)		
		wTree.get_widget("combo").set_sensitive(True)

class mintUploader(threading.Thread):

    def run(self):
	global so_far
	global filesize
	global url
	global progressbar
	global statusbar
	global host
	global user
	global password
	global path
	global filename
	global wTree
	global name
	
	wTree.get_widget("combo").set_sensitive(False)
	wTree.get_widget("upload_button").set_sensitive(False)

	try:
		statusbar.push(context_id, _("Connecting to the service..."))
		wTree.get_widget("main_window").window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))		

		so_far = 0
		progressbar.set_fraction(0)
		progressbar.set_text("0%")

		ftp = ftplib.FTP()
		ftp.connect(host, 21)
		print "'" + user + "'/'" + password + "'"
        	ftp.login(user, password)	        
		name = os.path.split(filename)[1]
		f = open(filename, "rb")

		statusbar.push(context_id, _("Uploading the file..."))
		if (path != "none"):
			try:
				ftp.mkd(path)
			except:
				pass
			ftp.cwd(path)
		timestamp = datetime.datetime.utcnow().strftime("%Y%m%d%H%M%S")
		directory = ftp.mkd(timestamp)
		ftp.cwd(directory)
		ftp.storbinary('STOR ' + name, f, 1024, callback=self.asciicallback)
		progressbar.set_fraction(1)
		f.close()
		ftp.quit()
		url = url.replace("<TIMESTAMP>", timestamp)
		url = url.replace("<FILE>", name)
		wTree.get_widget("txt_url").set_text(url)
		statusbar.push(context_id, "<span color='green'>" + _("File uploaded successfully.") + "</span>")
		label = statusbar.get_children()[0].get_children()[0]		
		label.set_use_markup(True)
		wTree.get_widget("copy_button").set_sensitive(True)				
	except Exception, detail:
		print detail
		statusbar.push(context_id, "<span color='red'>" + _("Upload failed.") + "</span>")		
		label = statusbar.get_children()[0].get_children()[0]		
		label.set_use_markup(True)
	finally:
		wTree.get_widget("main_window").window.set_cursor(None)		
		wTree.get_widget("combo").set_sensitive(False)
		wTree.get_widget("upload_button").set_sensitive(False)

    def asciicallback(self, buffer):
	global so_far	
	global progressbar
	global filesize
	
	so_far = so_far+len(buffer)-1
	pct = float(so_far)/filesize
	progressbar.set_fraction(pct)
        pct = int(pct * 100)
	progressbar.set_text(str(pct) + "%")
	print "so far:", pct, "%"
	return

class mintUploadWindow:
    """This is the main class for the application"""

    def __init__(self, filename):
	global filesize
	global wTree
	global filesizeSTR

	self.filename = filename

	#Set the Glade file
        self.gladefile = "/usr/lib/linuxmint/mintUpload/mintUpload.glade"
        wTree = gtk.glade.XML(self.gladefile,"main_window")

	wTree.get_widget("main_window").connect("destroy", gtk.main_quit)

	#i18n
	wTree.get_widget("txt_name").set_label("<big><b>" + _("Upload a file") + "</b></big>")
	wTree.get_widget("txt_guidance").set_label("<i>" + _("Upload and share a file") + "</i>") 
	wTree.get_widget("label2").set_label("<b>" + _("Upload service") + "</b>")
	wTree.get_widget("label3").set_label("<b>" + _("Local file") + "</b>")
	wTree.get_widget("label4").set_label("<b>" + _("Remote file") + "</b>")
	wTree.get_widget("label187").set_label(_("Name:"))
	wTree.get_widget("label188").set_label(_("Free space:"))
	wTree.get_widget("label196").set_label(_("Max file size:"))
	wTree.get_widget("label198").set_label(_("Persistence:"))
	wTree.get_widget("label195").set_label(_("Path:"))
	wTree.get_widget("label193").set_label(_("Size:"))
	wTree.get_widget("label190").set_label(_("Upload progress:"))
	wTree.get_widget("label191").set_label(_("URL:"))
	
	
	#Read the services files
	for service in os.listdir("/usr/lib/linuxmint/mintUpload/services"):
		openfile = open("/usr/lib/linuxmint/mintUpload/services/" + service)
                datalist = openfile.readlines()
		for j in range( len( datalist ) ):
		    if (str.find(datalist[j], "name=") > -1):
			name = datalist[j][5:]
			name = str.strip(name)
			wTree.get_widget("combo").append_text(name)
		    
	wTree.get_widget("combo").connect("changed", self.comboChanged)	
	wTree.get_widget("upload_button").connect("clicked", self.upload)	
	wTree.get_widget("copy_button").connect("clicked", self.copy)	
	wTree.get_widget("cancel_button").connect("clicked", gtk.main_quit)	

	# Print the name of the file in the GUI
	wTree.get_widget("txt_file").set_label(self.filename)

	# Calculate the size of the file
	filesize = os.path.getsize(self.filename)
	filesize = float(filesize)
	filesizeSTR = str(filesize) + _("B")
	if (filesize > 1000):
		filesizeF = round(filesize/1000, 1)
		filesizeSTR = str(filesizeF) + _("KB")
	if (filesize > 1000000):
		filesizeF = round(filesize/1000000, 1)
		filesizeSTR = str(filesizeF) + _("MB")
	if (filesize > 1000000000):
		filesizeF = round(filesize/1000000000, 1)
		filesizeSTR = str(filesizeF) + _("GB")
		
	wTree.get_widget("txt_size").set_label(filesizeSTR)

    def comboChanged(self, widget):
	global host
	global user
	global password
	global path
	global progressbar
	global space
	global maxsize
	global persistence
	global url
	global filesize
	global statusbar
	global wTree
	global context_id

	progressbar = wTree.get_widget("progressbar")
	statusbar = wTree.get_widget("statusbar")
	context_id = statusbar.get_context_id("mintUpload")

	#Get the selected service
	model = wTree.get_widget("combo").get_model()
        active = wTree.get_widget("combo").get_active()
        if active < 0:
        	return
        selectedService = model[active][0]

	#Read the services files until we find the one we want
	for service in os.listdir("/usr/lib/linuxmint/mintUpload/services"):
		openfile = open("/usr/lib/linuxmint/mintUpload/services/" + service)
                datalist = openfile.readlines()
		path="none"
		for j in range( len( datalist ) ):
		    if (str.find(datalist[j], "name=") > -1):
			name = datalist[j][5:]
			name = str.strip(name)
		    if (str.find(datalist[j], "user=") > -1):
			user = datalist[j][5:]
			user = str.strip(user)
		    if (str.find(datalist[j], "pass=") > -1):
			password = datalist[j][5:]
			password = str.strip(password)
		    if (str.find(datalist[j], "path=") > -1):
			path = datalist[j][5:]
			path = str.strip(path)
		    if (str.find(datalist[j], "host=") > -1):
			host = datalist[j][5:]
			host = str.strip(host)
		    if (str.find(datalist[j], "space=") > -1):
			space = datalist[j][6:]
			space = str.strip(space)
		    if (str.find(datalist[j], "url=") > -1):
			url = datalist[j][4:]
			url = str.strip(url)
		    if (str.find(datalist[j], "maxsize=") > -1):
			maxsize = datalist[j][8:]
			maxsize = str.strip(maxsize)
		    if (str.find(datalist[j], "persistence=") > -1):
			persistence = datalist[j][12:]
			persistence = str.strip(persistence)

		if (name == selectedService):
			print "name: '" + name + "'"	
			print "host: '" + host + "'"	
			print "user: '" + user + "'"	
			print "pass: '" + password + "'"	
			print "path: '" + path + "'"	
			print "persistence: '" + persistence + "'"	
			print "space: '" + space + "'"	
			print "url: '" + url + "'"	
			print "maxsize: '" + maxsize + "'"	
			spacecheck = spaceChecker()
			spacecheck.start()
			return True
				
    def upload(self, widget):
	global wTree

	#Upload the file
	wTree.get_widget("upload_button").set_sensitive(False)
	wTree.get_widget("combo").set_sensitive(False)
	uploader = mintUploader()
	uploader.start()
	return True

    def copy(self, widget):
	global url
	
	# get the clipboard
	clipboard = gtk.clipboard_get()
	clipboard.set_text(url)
	clipboard.store()

def my_storbinary(self, cmd, fp, blocksize=8192, callback=None):
    '''Store a file in binary mode.'''
    self.voidcmd('TYPE I')
    conn = self.transfercmd(cmd)
    while 1:
        buf = fp.read(blocksize)
        if not buf: break
        conn.sendall(buf)
	if callback: callback(buf)
    conn.close()
    return self.voidresp()

def my_storlines(self, cmd, fp, callback=None):
    '''Store a file in line mode.'''
    self.voidcmd('TYPE A')
    conn = self.transfercmd(cmd)
    while 1:
        buf = fp.readline()
        if not buf: break
        if buf[-2:] != CRLF:
            if buf[-1] in CRLF: buf = buf[:-1]
            buf = buf + CRLF
        conn.sendall(buf)
        if callback: callback(buf)
    conn.close()
    return self.voidresp()

ftplib.FTP.storbinary = my_storbinary  # use the patched version
ftplib.FTP.storlines = my_storlines  # use the patched version

if __name__ == "__main__":
    filename = sys.argv[1]
    mainwin = mintUploadWindow(filename)
    gtk.main()
    
